import sublime
import sublime_plugin
import desktop
import tempfile
import re
import textwrap
import os
import shutil
import threading
import datetime
import logging
import time
import inspect

installer = 0

class BI_TOOLS(sublime_plugin.TextCommand):
	def __init__(self, view):
		self.PTbaseDir = os.path.expanduser('~\Documents\Poseidon Tools\\')

AppDataLocal = os.path.expanduser('~\AppData\Local\\')
OALogDir = AppDataLocal + "ArmA 2 OA"
A2LogDir = AppDataLocal + "Arma 2"
A3LogDir = AppDataLocal + "Arma 3"
A3LLogDir = AppDataLocal + "Arma 3 Launcher"
DZLogDir = AppDataLocal + "DayZ"
TKOHLogDir = AppDataLocal + "Take On Helicopters"

PTbaseDir = os.path.expanduser('~\Documents\Poseidon Tools\\')
PTExportDir = PTbaseDir + 'Exports\\'
PTProjectsDir = PTbaseDir + 'Projects\\'
PTTempDir = PTbaseDir + 'Temp\\'
PTCfgDir = PTbaseDir + 'Config\\'
LogFile = PTbaseDir + "poseidonTools(ST2).rpt"
PTbaseList = [sublime.packages_path(), sublime.installed_packages_path(), PTbaseDir, PTExportDir, PTProjectsDir, PTTempDir, PTCfgDir]

if not os.path.exists(PTbaseDir):
	installer = 1

for item in PTbaseList:
	if not os.path.exists(item):
		os.makedirs(item)

if installer==1:
	print "not installed"

print "Base:		" + PTbaseDir 
print "Export:		" + PTExportDir 
print "Projects:	" + PTProjectsDir 
print "Temp: 		" + PTTempDir 
print "Cfg: 		" + PTCfgDir 

file1 = open(PTCfgDir + 'application_command_classes.dat', 'a+')
file2 = open(PTCfgDir + 'window_command_classes.dat', 'a+')
file3 = open(PTCfgDir + 'text_command_classes.dat', 'a+')
file4 = open(PTCfgDir + 'path.dat', 'w+')

file4.write("[\n")
for item in PTbaseList:
	file4.write('\t"' + item + '",\n')
file4.write('\t"config.Lock.time", "'+ str(datetime.datetime.now()) + '"\n]')

def initLogger(appName='Application', handlerType='StreamHandler', \
	loggerLevel='INFO', handlerLevel='DEBUG'):
	# Creating the logger object
	log = logging.getLogger(appName)
	log.setLevel(getattr(logging, loggerLevel))

	# Initializing logging settings in handler
	handler = getattr(logging, handlerType)()
	handler.setLevel(getattr(logging, handlerLevel))
	handler.setFormatter(logging.Formatter(
		'%(asctime)s - %(name)s - %(levelname)s - %(message)s'))

	# binding the handler to Logger object
	log.addHandler(handler)

def logger(Data,level="info"):
	entry = str(datetime.datetime.now()) + " [" + level + "] 1: Poseidon Tools[ST2] - " + Data
	print entry
	logFile = open(LogFile, 'a+')
	logFile.write(entry + "\n")
	logFile.close

logger("==============================================================")
logger("Poseidon Tools Initialized")
logger("Version: " + sublime.version())
logger("OS: " + sublime.platform() + " (" + sublime.arch() + ")")
logger("-")
# logger("Directory loaded: " + sublime.Window.folders())
sublime.log_commands(0)